unit UVideoteca;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, Grids, DBGrids, StdCtrls, EditBuscar, DBTables, Buttons,
  ExtCtrls, ExtDlgs, Qrctrls, QuickRpt, DBCtrls, jpeg, clipbrd, Menus, variants,
  dxDBTLCl, dxGrClms, dxTL, dxDBCtrl, dxDBGrid, dxCntner, dxExEdtr;

type
  TVideoteca = class(TForm)
    Table1: TTable;
    Titulo: TStringField;
    Soporte: TStringField;
    FormatoDeVideo: TStringField;
    Estado: TStringField;
    Duracion: TTimeField;
    FechaAdquisicion: TDateField;
    Comentario: TMemoField;
    Portada: TGraphicField;
    ContraPortada: TGraphicField;
    FechaPelicula: TDateField;
    Vista: TBooleanField;
    Disponible: TBooleanField;
    DataSource1: TDataSource;
    QRPeliculas: TQuickRep;
    QRBand1: TQRBand;
    QRSysData1: TQRSysData;
    QRShape1: TQRShape;
    QRBand2: TQRBand;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    Panel1: TPanel;
    Label1: TLabel;
    LNumeroRegistro: TLabel;
    LTotalRegistros: TLabel;
    SpeedButton1: TSpeedButton;
    Button1: TButton;
    EditBuscar1: TEditBuscar;
    CheckBox1: TCheckBox;
    OpenPictureDialog1: TOpenPictureDialog;
    Panel3: TPanel;
    Splitter2: TSplitter;
    ScrollBox1: TScrollBox;
    Splitter1: TSplitter;
    Memo1: TMemo;
    DBImage1: TDBImage;
    Splitter4: TSplitter;
    DBImage2: TDBImage;
    Panel2: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    BitVaciar: TBitBtn;
    BitActualizar: TBitBtn;
    Button3: TButton;
    Button2: TButton;
    Button4: TButton;
    Button5: TButton;
    Image1: TImage;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Codigo: TdxDBGridMaskColumn;
    dxDBGrid1Titulo: TdxDBGridMaskColumn;
    dxDBGrid1Soporte: TdxDBGridMaskColumn;
    dxDBGrid1FormatoDeVideo: TdxDBGridMaskColumn;
    dxDBGrid1Estado: TdxDBGridMaskColumn;
    dxDBGrid1Duracion: TdxDBGridTimeColumn;
    dxDBGrid1FechaAdquisicion: TdxDBGridDateColumn;
    dxDBGrid1Comentario: TdxDBGridMemoColumn;
    dxDBGrid1Portada: TdxDBGridGraphicColumn;
    dxDBGrid1ContraPortada: TdxDBGridGraphicColumn;
    dxDBGrid1FechaPelicula: TdxDBGridDateColumn;
    dxDBGrid1Vista: TdxDBGridCheckColumn;
    dxDBGrid1Disponible: TdxDBGridCheckColumn;
    Button6: TButton;
    Button7: TButton;
    SaveDialog1: TSaveDialog;
    Table1Codigo: TFloatField;
    DBNavigator1: TDBNavigator;
    procedure Button1Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure BitVaciarClick(Sender: TObject);
    procedure BitActualizarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure dxDBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure Button6Click(Sender: TObject);
    procedure EditBuscar1KeyPress(Sender: TObject; var Key: Char);
    procedure Button7Click(Sender: TObject);
    procedure Table1BeforeInsert(DataSet: TDataSet);
    procedure Table1AfterInsert(DataSet: TDataSet);
    procedure Table1PostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Videoteca: TVideoteca;
  Validando: Boolean;
  UltimaPulsacion: Double;
  CodigoActual: String;
  SiguienteCodigo: Double;
  resourcestring MensajeDeError = ' El Codigo ya existe ';

var
  RegistroActual: integer;

implementation

{$R *.DFM}

procedure TVideoteca.Button1Click(Sender: TObject);
var
  Registro : Integer;
begin
Registro := Table1.RecNo;
if not EditBuscar1.Buscar then
begin
  Table1.RecNo:= Registro;
  ShowMessage('No se ha encontrado ninguna coincidencia');
end;
{(Registro);}
{Label1.Caption := IntToStr(registro);}

end;

procedure TVideoteca.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  if not Validando then
    Memo1.Text := Table1.FieldValues['Comentario']{Comentario.Value};
{  IPortada.Picture.Bitmap.loadfromclipboard ;}
  LNumeroRegistro.Caption := IntToStr(Table1.RecNo);
  LTotalRegistros.Caption := IntToStr(Table1.RecordCount);
end;

procedure TVideoteca.BitVaciarClick(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TVideoteca.BitActualizarClick(Sender: TObject);
begin
  Validando := True;
  Table1.Edit;
  Table1.FieldValues['Comentario'] := Memo1.Text;
  Table1.Post;
  Validando := False;
end;

procedure TVideoteca.FormCreate(Sender: TObject);
begin
Validando := False;
UltimaPulsacion := 0;
end;

procedure TVideoteca.Button2Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
  begin
    Table1.edit;
    Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);
    Clipboard.Assign(Image1.Picture);
    DBImage1.PasteFromClipboard;
{    DBImage1.Picture.LoadFromFile(OpenPictureDialog1.FileName); {solo para BMP}
    Table1.Post;
  end;
end;

procedure TVideoteca.CheckBox1Click(Sender: TObject);
begin
EditBuscar1.CaseSensitive := CheckBox1.Checked;
end;

procedure TVideoteca.SpeedButton1Click(Sender: TObject);
begin
QRPeliculas.Preview;
end;

procedure TVideoteca.Button3Click(Sender: TObject);
begin
if not (Table1.State in [dsedit,dsinsert]) then Table1.edit;
Table1.FieldByName('ContraPortada').Value := null;
Table1.Post;
end;

procedure TVideoteca.Button4Click(Sender: TObject);
begin
if not (Table1.State in [dsedit,dsinsert]) then Table1.edit;
Table1.FieldByName('Portada').Value := null;
Table1.Post;
end;

procedure TVideoteca.Button5Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
  begin
    Table1.edit;
    Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);
    Clipboard.Assign(Image1.Picture);
    DBImage2.PasteFromClipboard;
{    DBImage1.Picture.LoadFromFile(OpenPictureDialog1.FileName); {solo para BMP}
    Table1.Post;
  end;
end;

procedure TVideoteca.dxDBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if (dxDBGrid1.FocusedField.FieldName = 'Codigo')and
    not ((Table1.State = dsEdit) or (Table1.State = dsInsert)) then
    if Key in ['0'..'9'] then
    begin
      if (Time - UltimaPulsacion) < 0.00001 then
      begin
        UltimaPulsacion := Time;
        if Length(CodigoActual) < 7 then CodigoActual := CodigoActual + Key;
        Table1.FindNearest([CodigoActual]);
      end
      else
      begin
        UltimaPulsacion := Time;
        CodigoActual := Key;
        Table1.FindNearest([CodigoActual]);
      end;
      Key := #0;
    end;
end;

procedure TVideoteca.Button6Click(Sender: TObject);
Var
  Registro: Integer;
begin
Registro := Table1.RecNo;
Table1.Next;
if not EditBuscar1.BuscaSiguiente then
begin
  Table1.RecNo:= Registro;
  ShowMessage('No existen ms coincidencias');
end;
end;

procedure TVideoteca.EditBuscar1KeyPress(Sender: TObject; var Key: Char);
begin
If Key = #13 then
  Button1Click(nil);
end;

procedure TVideoteca.Button7Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
    dxDBGrid1.SaveToXLS(SaveDialog1.FileName,true);
end;

procedure TVideoteca.Table1BeforeInsert(DataSet: TDataSet);
var
  i: Integer;
begin
  Table1.DisableControls;
  Table1.First;
  i := 1;
  While (not Table1.Eof) and (Table1Codigo.Value = i) do
  begin
    Table1.Next;
    i := i + 1;
  end;
  if Table1.Eof then
    SiguienteCodigo := Table1Codigo.Value + 1
  else
    SiguienteCodigo := i;
  Table1.EnableControls;
end;

procedure TVideoteca.Table1AfterInsert(DataSet: TDataSet);
begin
Table1Codigo.Value := SiguienteCodigo;
end;

procedure TVideoteca.Table1PostError(DataSet: TDataSet; E: EDatabaseError;
  var Action: TDataAction);
var
  CodigoDup: Double;
begin
  if  E.Message = 'Key violation.' then
  begin
//    RegistroActual := Table1.RecNo;
//    E.CreateRes(@MensajeDeError);
    Table1.DisableControls;
    CodigoDup := Table1Codigo.Value;
    Table1Codigo.Value := 999999;
    Table1.FindKey([CodigoDup]);
    While (not Table1.Eof) and (Table1Codigo.Value = CodigoDup) do
    begin
      Table1.Next;
      CodigoDup := CodigoDup + 1;
    end;
    if Table1.Eof then
      SiguienteCodigo := CodigoDup + 1
    else
      SiguienteCodigo := CodigoDup;
    Table1.EnableControls;
    Table1.FindKey([999999]);
    if (Table1.State <> dsedit) or (Table1.State <> dsinsert) then
      Table1.Edit;
    Table1Codigo.Value := SiguienteCodigo;
    Table1.Post;
//    Table1.Refresh;
//    dxDBGrid1.Refresh;
//    Table1.locate('codigo',SiguienteCodigo,[]);
//    dxDBGrid1.FocusedField := Table1Codigo;
//    dxDBGrid1.FocusedColumn := Table1.RecNo;
    ShowMessage('El codigo ya existe y se le ha asignado el: '+FloatToStr(SiguienteCodigo));
    Action := daAbort;
//     Table1.RecNo := RegistroActual;
  end;
end;

procedure TVideoteca.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    if (Table1.State = dsedit) or (Table1.State = dsinsert) then
      Table1.Post;
end;

end.
